
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  Silver
#property indicator_color6  Lime
#property indicator_color7  Red
#property indicator_width1 2
#property indicator_width6 2
#property indicator_width7 2
//+------------------------------------------------------------------+
#property indicator_level1 90
#property indicator_level2 10
#property indicator_levelstyle DRAW_LINE
#property indicator_levelcolor MediumBlue
//+------------------------------------------------------------------+
extern int    STCPeriod    = 10;
extern bool   T3Original =false;
extern int    T3_PeriodFast=13;// 5    
extern int    T3_PeriodSlow=21;//13
extern  double T3_Factor=0.618;

//+------------------------------------------------------------------+
double stcBuffer[];
double macdBuffer[];
double fastKBuffer[];
double fastDBuffer[];
double fastKKBuffer[];
double Upper[];
double Lower[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,stcBuffer);
   SetIndexBuffer(1,macdBuffer);
   SetIndexBuffer(2,fastKBuffer);
   SetIndexBuffer(3,fastDBuffer);
   SetIndexBuffer(4,fastKKBuffer);
   SetIndexBuffer(5,Upper);
   SetIndexBuffer(6,Lower);
   
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexStyle(5,DRAW_LINE, EMPTY, 2);
   SetIndexStyle(6,DRAW_LINE, EMPTY, 2);
   
   IndicatorShortName(WindowExpertName()+ "("+STCPeriod+","+T3_PeriodFast+","+T3_PeriodSlow+")");
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
//+------------------------------------------------------------------+       
      limit = Bars-counted_bars;
  
      for(i = limit; i >= 0; i--)
      {
         macdBuffer[i] = iCustom(Symbol(), 0,"T3",T3Original,T3_PeriodFast,T3_Factor,0, i)-
                         iCustom(Symbol(), 0,"T3",T3Original,T3_PeriodSlow,T3_Factor,0, i);
//+------------------------------------------------------------------+         
         double lowMacd  = minValue(macdBuffer,i);
         double highMacd = maxValue(macdBuffer,i)-lowMacd;
            if (highMacd > 0)
                  fastKBuffer[i] = 100*((macdBuffer[i]-lowMacd)/highMacd);
            else  fastKBuffer[i] = fastKBuffer[i+1];
                  fastDBuffer[i] = fastDBuffer[i+1]+0.5*(fastKBuffer[i]-fastDBuffer[i+1]);
//+------------------------------------------------------------------+                     
         double lowStoch  = minValue(fastDBuffer,i);
         double highStoch = maxValue(fastDBuffer,i)-lowStoch;
            if (highStoch > 0)
                  fastKKBuffer[i] = 100*((fastDBuffer[i]-lowStoch)/highStoch);
            else  fastKKBuffer[i] = fastKKBuffer[i+1];
                  stcBuffer[i]    = stcBuffer[i+1]+0.5*(fastKKBuffer[i]-stcBuffer[i+1]);
      }
   for(i = limit; i >= 0; i--)
   {
   Upper[i]=EMPTY_VALUE;
    Lower[i]=EMPTY_VALUE;
   if (stcBuffer[i] > stcBuffer[i+1]) {
    Upper[i] = stcBuffer[i]; 
    Upper[i+1] = stcBuffer[i+1]; 
    }
    
  if (stcBuffer[i] < stcBuffer[i+1])   {
   Lower[i] = stcBuffer[i]; 
   Lower[i+1] = stcBuffer[i+1]; }
               }
        
      return(0);
}

//+------------------------------------------------------------------+
//| ...                                          |
//+------------------------------------------------------------------+

double minValue(double& array[],int shift)
{
   double minValue = array[shift];
            for (int i=1; i<STCPeriod; i++) minValue = MathMin(minValue,array[shift+i]);
   return(minValue);
}
double maxValue(double& array[],int shift)
{
   double maxValue = array[shift];
            for (int i=1; i<STCPeriod; i++) maxValue = MathMax(maxValue,array[shift+i]);
   return(maxValue);
}